Subject: RE: bug#25627: 25.1; `help-make-xrefs' loads `cl-extra.el' now

From: Drew Adams <[email-masked]>
Date: Tue, 7 Feb 2017 16:18:05 -0800 (PST)

> > The Emacs emulation of Common-Lisp `dolist' should be called
> > (only) `cl-dolist'
> 
> This is exactly what cl-lib.el does. cl.el does the wrong thing,
> which is why its use is discouraged.

Agreed, as far as that goes.  But `dolist' is an exception
(it is the only one, though).  There are _relatively_ few
such name clashes.

> > But again, this bug report is about unnecessarily
> > autoloading `cl-extra.el'.  It is not about `cl.el'.
> 
> Does the fact that cl-extra sets byte-compile-dynamic help
> with your concerns at all? ...
> byte-compile-dynamic is a variable defined in `bytecomp.el'.

Yes, I think it does.  I wasn't aware of this feature.

>From (elisp) `Dynamic Loading' it appears that there is
no bug here.  If you think so too then please close.

Why don't more (even most) of the files distributed with
Emacs have this variable set (to non-nil)?  Searching the
Emacs 25.1 distributed Lisp files, I find only these that
use the variable:

dired-aux.el
dired-x.el
wdired.el
wid-edit.el
calendar.el
cl-extra.el
cl-lib.el
cl-macs.el
cl-seq.el
sendmail.el
executable.el
pcvs-util.el

Why (only) those?